package mi.hdm;

import mi.hdm.filesystem.FileManager;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.io.File;
import java.io.IOException;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.SourceDataLine;


/**
 * A class to run background music in the application
 */
public class MusicPlayer implements Runnable {

    private final static Logger log = LogManager.getLogger(MusicPlayer.class);

    private final static String FILE_NAME = "/music/GrandEtude_DagReinbott.wav";



    @Override
    public void run() {
        final String ABSOLUTE_FILE_NAME = FileManager.getAbsolutePathFromResourceFolder(FILE_NAME);
        while(!Thread.currentThread().isInterrupted()) {
            playSound(ABSOLUTE_FILE_NAME);
        }
    }

    //solution found on https://stackoverflow.com/questions/23255162/looping-audio-on-separate-thread-in-java
    private void playSound(String fileName)
    {
        File soundFile = new File(fileName);
        log.debug("Found file {}", soundFile);
        AudioInputStream audioInputStream = null;
        try
        {
            audioInputStream = AudioSystem.getAudioInputStream(soundFile);
            log.info("Found file {}", soundFile);
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
        AudioFormat audioFormat = audioInputStream.getFormat();
        SourceDataLine line = null;
        DataLine.Info info = new DataLine.Info(SourceDataLine.class, audioFormat);
        try
        {
            line = (SourceDataLine) AudioSystem.getLine(info);
            line.open(audioFormat);
        }
        catch (LineUnavailableException e)
        {
            e.printStackTrace();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
        line.start();
        int nBytesRead = 0;
        byte[] abData = new byte[128000];
        while (nBytesRead != -1)
        {
            try
            {
                nBytesRead = audioInputStream.read(abData, 0, abData.length);
            }
            catch (IOException e)
            {
                e.printStackTrace();
            }
            if (nBytesRead >= 0)
            {
                int nBytesWritten = line.write(abData, 0, nBytesRead);
            }
        }
        line.drain();
        line.close();
    }

}
