package mi.hdm.components;

import javafx.scene.control.CheckBox;
import mi.hdm.helpers.ColorHelper;
import mi.hdm.recipes.Category;

/**
 * Checkbox UI element for categories with the appropriate background color
 */
public class CategoryCheckBox extends CheckBox {
    private final Category category;

    public CategoryCheckBox(Category category) {
        super(category.getName());
        this.category = category;

        this.setStyle(
                "-fx-background-color:" + category.getColourCode() + ";" +
                        "-fx-padding: 4px;" +
                        "-fx-text-fill: " + ColorHelper.getTextColorForBackground(getAssociatedCategory().getColourCode()) + ";" +
                        "-fx-background-radius: 10px;"
        );
    }

    public Category getAssociatedCategory() {
        return category;
    }
}
