package mi.hdm.components;

import javafx.scene.control.Label;
import javafx.scene.layout.HBox;
import javafx.scene.text.Text;
import mi.hdm.recipes.RecipeComponent;

public class IngredientLabel extends HBox {
    private final int amount;
    private final RecipeComponent component;

    public IngredientLabel(int amount, RecipeComponent component) {
        super();
        this.amount = amount;
        this.component = component;

        Text labelAmount = new Text(amount + "    " + component.getMeasurement().getAbbreviation());
        Text labelName = new Text(component.getName());

        getChildren().addAll(labelAmount, labelName);

        setSpacing(16.0);
        setStyle("-fx-padding: 5px;");
    }

    public int getAmount() {
        return amount;
    }

    public RecipeComponent getComponent() {
        return component;
    }
}
