package mi.hdm.helpers;

public class ColorHelper {
    public static String getTextColorForBackground(String backgroundColor) {
        return getTextColorForBackground(backgroundColor, 0.6);
    }

    public static String getTextColorForBackground(String backgroundColor, double threshold) {
        String number = backgroundColor.substring(1);
        double luminance = calculateRelativeLuminance(number);
        if (luminance > threshold) {
            return "#000000";
        }
        return "#FFFFFF";
    }

    /**
     * This method returns the relative luminance clipped between 0-1 of a color represented in hex.
     */
    private static double calculateRelativeLuminance(String hexCode) {
        //source for reference: https://stackoverflow.com/questions/596216/formula-to-determine-perceived-brightness-of-rgb-color
        int red = Integer.parseInt(hexCode.substring(0, 2), 16);
        int green = Integer.parseInt(hexCode.substring(2, 4), 16);
        int blue = Integer.parseInt(hexCode.substring(4, 6), 16);
        return (0.2126 * red + 0.7152 * green + 0.0722 * blue) / 256;
    }

    public static String numberToColorCodeString(int colourCode) {
        String intToHex = Integer.toHexString(colourCode);
        intToHex = intToHex
                .indent(6 - intToHex.length())
                .replace(" ", "0");
        return ("#" + intToHex).strip();
    }
}
